"""DBMaker Database Adapter Module"""

__version__='$Revision: 1.3 $'[11:-2]

#  Copyright (C) 2000 FlicNET and Mike Ivanov <mike@flic.net>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

import string

import Shared.DC.ZRDB.THUNK
TM = Shared.DC.ZRDB.THUNK.THUNKED_TM

import ODBC.DBMaker
DBM = ODBC.DBMaker

type_mapping = {
    DBM.CHAR 		: 's',
    DBM.VARCHAR		: 's',
    DBM.LONGVARCHAR	: 's',
    
    DBM.BINARY		: 's',
    DBM.VARBINARY	: 's',
    DBM.LONGVARBINARY	: 's',
    
    DBM.INTEGER		: 'i',
    DBM.TINYINT		: 'i',
    DBM.SMALLINT	: 'i',
    DBM.BIGINT		: 'i',
    DBM.DECIMAL		: 'n',
    DBM.NUMERIC		: 'n',
    DBM.BIT		: 'i',
    
    DBM.REAL		: 'n',
    DBM.FLOAT		: 'n',
    DBM.DOUBLE		: 'n',
    
    DBM.DATE		: 'd',
    DBM.TIME		: 'd',
    DBM.TIMESTAMP	: 'd',
    }

class DB( TM) :

    def __init__( self, connection_string='') :
	(dsn,user,passwd) = string.split( connection_string)
	
	self.conn = DBM.Connect( dsn, user, passwd)
	self.conn.setconnectoption( DBM.SQL.AUTOCOMMIT, DBM.SQL.AUTOCOMMIT_OFF)
	self.cursor = self.conn.cursor()
    
    def _begin( self) :
	pass
	
    def _finish( self) :
	self.conn.commit()

    def _abort( self) :
	self.conn.rollback()
    
    def query( self, query_string, max_rows=100000) :
	self._register()
	
        result = None
	description = None
	selected = 0

	queries = filter( string.strip, string.split( query_string, '\0'))

        for query in queries :
            self.cursor.execute( query)
	    descr = self.cursor.description
            if descr :
                if selected :
                    raise ValueError, 'multiple selects are not allowed'

		selected = 1		
		description = descr
                result = self.cursor.fetchmany( max_rows)

	if not selected :
	    return ((),()) # looks like owl, eh? :-)
	
	items = []
	for d in description :
	    items.append({
		'name'  : d[0],
		'type'  : type_mapping[d[1]],
		'width' : d[4],
		'null'  : d[6]
		})
	
	return (items,result)

